#include <ext/rope>
using namespace std;
using namespace __gnu_cxx;
const int N = 2e6 + 50;
char buf[N];
int main()
{
    scanf("%s", buf);
    rope<char> s = buf;
    int n = s.size(), m;
    scanf("%d", &m);
    while (m--)
    {
        char op[4];
        int v;
        scanf("%s%d", op, &v);
        if (*op == 'A')
            printf("%c\n", s[v - 1]);
        if (*op == 'M')
        {
            if (v > 0)
            {
                s.append(s.substr(0, v));
                s.erase(0, v);
            }
            if (v < 0)
            {
                s.insert(0, s.substr(n + v, abs(v)));
                s.erase(n, abs(v));
            }
        }
    }
    return 0;
}